# TODO (dmt): Validate user input!
# TODO (dmt): Add doc!


class SetFeatures:
    def __init__(self):
        self.set_features = None

    def __get__(self, instance, owner):
        return self.set_features

    def __set__(self, instance, value):
        self.set_features = [int(i) for i in value.split(",")]


class CutTimeStamp:
    def __init__(self):
        self.cut_time_stamp = False

    def __get__(self, instance, owner):
        return self.cut_time_stamp

    def __set__(self, instance, value):
        self.cut_time_stamp = bool(value)


class BlockSize:
    def __init__(self):
        self.block_size = None

    def __get__(self, instance, owner):
        return self.block_size

    def __set__(self, instance, value):
        self.block_size = int(value)


class InputFile:
    def __init__(self):
        self.input_file = None

    def __get__(self, instance, owner):
        return self.input_file

    def __set__(self, instance, value):
        self.input_file = value


class LearnDir:
    def __init__(self):
        self.learn_dir = None

    def __get__(self, instance, owner):
        return self.learn_dir

    def __set__(self, instance, value):
        self.learn_dir = value


class MaxLearnDir:
    def __init__(self):
        self.max_learn_dir = None

    def __get__(self, instance, owner):
        return self.max_learn_dir

    def __set__(self, instance, value):
        self.max_learn_dir = value


class UseExistingModels:
    def __init__(self):
        self.use_existing_models: bool = False

    def __get__(self, instance, owner):
        return self.use_existing_models

    def __set__(self, instance, value):
        self.use_existing_models = value


class KnowledgeDir:
    def __init__(self):
        self.knowledge_dir = None

    def __get__(self, instance, owner):
        return self.knowledge_dir

    def __set__(self, instance, value):
        self.knowledge_dirk = value


class SetTargets:
    def __init__(self):
        self.set_targets = None

    def __get__(self, instance, owner):
        return self.set_targets

    def __set__(self, instance, value):
        self.set_targets = value


class SortTimeStamp:
    def __init__(self):
        self.sort_time_stamp = False

    def __get__(self, instance, owner):
        return self.sort_time_stamp

    def __set__(self, instance, value):
        self.sort_time_stamp = value


class MaxBlocks:
    def __init__(self):
        self.max_blocks = 20

    def __get__(self, instance, owner):
        return self.max_blocks

    def __set__(self, instance, value):
        self.max_blocks = value


class StackIterations:
    def __init__(self):
        self.stack_iterations = 20

    def __get__(self, instance, owner):
        return self.stack_iterations

    def __set__(self, instance, value):
        self.stack_iterations = value


class LearnblockMinimum:
    def __init__(self):
        self.learnblock_minimum = 10

    def __get__(self, instance, owner):
        return self.learnblock_minimum

    def __set__(self, instance, value):
        self.learnblock_minimum = value


class MaxCategories:
    def __init__(self):
        self.max_categories = 10

    def __get__(self, instance, owner):
        return self.max_categories

    def __set__(self, instance, value):
        self.max_categories = value


class SigmaZetaCutoff:
    def __init__(self):
        self.sigma_zeta_cutoff = 10

    def __get__(self, instance, owner):
        return self.sigma_zeta_cutoff

    def __set__(self, instance, value):
        self.sigma_zeta_cutoff = value


class MinCategorySize:
    def __init__(self):
        self.min_category_size = 10

    def __get__(self, instance, owner):
        return self.min_category_size

    def __set__(self, instance, value):
        self.min_category_size = value


class MaxModelTargets:
    def __init__(self):
        self.max_model_targets = 10

    def __get__(self, instance, owner):
        return self.max_model_targets

    def __set__(self, instance, value):
        self.max_model_targets = value


class MaxTargetError:
    def __init__(self):
        self.max_target_error = 10

    def __get__(self, instance, owner):
        return self.max_target_error

    def __set__(self, instance, value):
        self.max_target_error = value


class MaxFeatures:
    def __init__(self):
        self.max_features = 10

    def __get__(self, instance, owner):
        return self.max_features

    def __set__(self, instance, value):
        self.max_features = value


class MaxFilterX:
    def __init__(self):
        self.max_filter_x = 10

    def __get__(self, instance, owner):
        return self.max_filter_x

    def __set__(self, instance, value):
        self.max_filter_x = value


class MaxModelsReduction:
    def __init__(self):
        self.max_models_reduction = 10

    def __get__(self, instance, owner):
        return self.max_models_reduction

    def __set__(self, instance, value):
        self.max_models_reduction = value


class MinTestAccuracy:
    def __init__(self):
        self.min_test_accuracy = 10

    def __get__(self, instance, owner):
        return self.min_test_accuracy

    def __set__(self, instance, value):
        self.min_test_accuracy = value


class MaxTestErrorAvg:
    def __init__(self):
        self.max_test_error_avg = 10

    def __get__(self, instance, owner):
        return self.max_test_error_avg

    def __set__(self, instance, value):
        self.max_test_error_avg = value


class MaxTestErrorMax:
    def __init__(self):
        self.max_test_error_max = 10

    def __get__(self, instance, owner):
        return self.max_test_error_max

    def __set__(self, instance, value):
        self.max_test_error_max = value


class ReliabilitySample:
    def __init__(self):
        self.reliability_sample = 10

    def __get__(self, instance, owner):
        return self.reliability_sample

    def __set__(self, instance, value):
        self.reliability_sample = value


class MinReliability:
    def __init__(self):
        self.min_reliability = 10

    def __get__(self, instance, owner):
        return self.min_reliability

    def __set__(self, instance, value):
        self.min_reliability = value


class ReduceModelRedundancy:
    def __init__(self):
        self.reduce_model_redundancy = False

    def __get__(self, instance, owner):
        return self.reduce_model_redundancy

    def __set__(self, instance, value):
        self.reduce_model_redundancy = value


class DeconstStrategy:
    def __init__(self):
        self.deconst_strategy = ""

    def __get__(self, instance, owner):
        return self.deconst_strategy

    def __set__(self, instance, value):
        self.deconst_strategy = value


class DeconstMode:
    def __init__(self):
        self.deconst_mode = ""

    def __get__(self, instance, owner):
        return self.deconst_mode

    def __set__(self, instance, value):
        self.deconst_mode = value


class DeconstMaxDistanceT:
    def __init__(self):
        self.deconst_max_distance_t = 10

    def __get__(self, instance, owner):
        return self.deconst_max_distance_t

    def __set__(self, instance, value):
        self.deconst_max_distance_t = value


class ForceTimeExpansion:
    def __init__(self):
        self.force_time_expansion = 10

    def __get__(self, instance, owner):
        return self.force_time_expansion

    def __set__(self, instance, value):
        self.force_time_expansion = value
